#ifndef __SGV_MESSAGE__
#define __SGV_MESSAGE__

#include "SgvSocket.h"
#include "ViewImage.h"
#include <vector>
#include <map>
#include <string>


namespace sigverse
{
	class RecvMsgEvent
	{
	private:
		std::string   m_from;
		std::string   m_msg;
	public:
		bool  setData(std::string data, int size);

		//! MG[WFg擾                                                                
		const char *getSender() { return m_from.c_str(); }

		//! iԖڂ̎̕擾                                                                           
		const char *getMsg() { return m_msg.c_str(); }
	};

	class SIGService
	{
	public:
		SIGService(std::string name);
		SIGService();
		virtual ~SIGService();

		//! bZ[WM 
		bool sendMsg(std::string to, std::string msg);

		//! T[oGeBeBRg[ɃbZ[W𒼐ڑM
		//! T[rXɐڑς݂̃GeBeBɂ̂ݑM
		bool sendMsgToCtr(std::string to, std::string msg);

		//! bZ[WM(肪) 
		bool sendMsg(std::vector<std::string> to, std::string msg);

		//! T[oɐڑ
		bool connect(std::string host, int port);

		//! T[oƐؒf
		bool disconnect();

		//! Rg[Ƃ̐ڑؒf(GeBeBw)
		bool disconnectFromController(std::string entityName);

		//! ڑ̑SRg[Ɛؒf
		void disconnectFromAllController();

		//! r[[Ƃ̐ڑؒf
		void disconnectFromViewer();

		//! f[^M[vJn(bZ[WMRg[̐ڑNGXgJnj
		//@ time [v(sec), -1.0͖
		void startLoop(double time = -1.0);

		//! T[oARg[Ar[[f[^MĂ邩ǂ`FbN(usec}CNb)
		bool checkRecvData(int usec);

		//! r[[ɐڑ
		//@ ڑɂ̓r[[𗧂グĂKv
		bool connectToViewer();

		//! r[[ɐڑ
		bool getIsConnectedView(){return m_connectedView;}

		/** 
		* @brief GeBeBJ摜f[^r[[擾
		* @param entityName       JGeBeB
		* @param camID            JIDԍ
		* @param cbit             rbg[x
		* @param size             C[WTCY
		*/
		ViewImage* captureView(std::string entityName, 
			int camID = 1,
			ColorBitType cbit = COLORBIT_24, 
			ImageDataSize size = IMAGE_320X240);

		/** 
		* @brief GeBeBJ王ɂIuWFNg܂ł̋擾
		* @param entityName       GeBeB
		* @param offset           f[^offsetl
		* @param range            f[^擾\͈
		* @param camID            JIDԍ
		* @param cbit             rbg[x
		*/
		unsigned char distanceSensor(std::string entityName, 
			double offset = 0.0, 
			double range = 255.0, 
			int camID = 1,
			ColorBitType cbit = DEPTHBIT_8
			);

		/** 
		* @brief GeBeBJ琅ʕ̋f[^擾
		* @param entityName       GeBeB
		* @param offset           f[^offsetl
		* @param range            f[^擾\͈
		* @param camID            JIDԍ
		* @param cbit             rbg[x
		* @param size             f[^TCY
		*/
		ViewImage* distanceSensor1D(std::string entityName, 
			double offset = 0.0, 
			double range = 255.0, 
			int camID = 1,
			ColorBitType cbit = DEPTHBIT_8,
			sigverse::ImageDataSize size = IMAGE_320X1);

		/** 
		* @brief GeBeBJ2f[^擾
		* @param entityName       GeBeB
		* @param offset           f[^offsetl
		* @param range            f[^擾\͈
		* @param camID            JIDԍ
		* @param cbit             rbg[x
		* @param size             f[^TCY
		*/
		ViewImage* distanceSensor2D(std::string entityName, 
			double offset = 0.0, 
			double range = 255.0, 
			int camID = 1,
			ColorBitType cbit = DEPTHBIT_8,
			sigverse::ImageDataSize size = IMAGE_320X240);


		/** 
		* @brief ␳O̐[x摜(zbuffer)擾
		* @param entityName       GeBeB
		* @param offset           f[^offsetl
		* @param range            f[^擾\͈
		* @param camID            JIDԍ
		* @param cbit             rbg[x
		* @param size             f[^TCY
		*/
		ViewImage* getDepthImage(std::string entityName, 
			double offset = 0.0, 
			double range = 255.0, 
			int camID = 1,
			ColorBitType cbit = DEPTHBIT_8,
			sigverse::ImageDataSize size = IMAGE_320X240);


		//! ̃T[rX擾
		std::string getName() { return m_name; }

		//! ̃T[rXݒ肷
		void setName(std::string name) { m_name = name; }

		//! T[oɐڑ̃T[rX̐擾
		int getNewServiceNum() { return (int)m_elseServices.size() ; }

		//! T[oɐڑ̑̃T[rXׂĎ擾
		std::vector<std::string> getAllOtherServices() { return m_elseServices; }

		//! ڑĂGeBeB̖O擾
		std::vector<std::string> getAllConnectedEntitiesName() {
			return m_entitiesName;
		}

		//! T[oɐڑĂ鑼̃T[rX擾(x擾ƊJ)
		/*
		std::string getElseServiceName() {
			int size = (int)m_elseServices.size(); 
			std::string name = m_elseServices[size - 1];
			m_elseServices.pop_back();
			return name;
		}
		*/

		//! T[oɐڑĂ鑼̃T[rXǉ
		//void setElseServiceName(std::string name) {
		//m_elseServices.push_back(name);
		//}

		SgvSocket* getSgvSocket(){
			return m_sgvsock;
		}

		//! Rg[SgvSocket擾
		SgvSocket* getControllerSocket(std::string name){
			std::map<std::string, sigverse::SgvSocket*>::iterator it;
			it = m_consocks.find(name);
			// SgvSocket
			if(it != m_consocks.end())
				return (*it).second;
			// SgvSocketȂ
			else
				return NULL;
		}

		//! ڑ̃Rg[̐擾
		int getConnectedControllerNum() {
			return (int)m_consocks.size();
		}

		//! r[[disconnectƂɎIɃ[v甲
		void setAutoExitLoop(bool flag){m_autoExitLoop = flag;}

		//! r[[disconnectƂɎIɃvZXI
		void setAutoExitProc(bool flag){m_autoExitProc = flag;}

		//! ŏɌĂяo
		virtual void onInit(){}

		//! bZ[WMCxgnh
		virtual void onRecvMsg(RecvMsgEvent &evt) {}

		//! IɌĂяo
		virtual double onAction() { return 0.0;}

	private:
		ViewImage* getDistanceImage(std::string entityName, 
			double offset, 
			double range, 
			int camID,
			int dimension,
			ColorBitType cbit,
			sigverse::ImageDataSize size);


	protected:
		//! socket(for server)
		sigverse::SgvSocket *m_sgvsock;

		//! socket(for viewer)
		sigverse::SgvSocket *m_viewsock;

		//! GeBeB̖OƃRg[p\Pbg̑Ή
		std::map<std::string, SgvSocket*> m_consocks;

		//! ڑ̑SGeBeB
		std::vector<std::string> m_entitiesName;

		//! name
		std::string m_name;

		//! ̃T[rX̖O
		std::vector<std::string> m_elseServices;

		//! ڑT[ozXg
		std::string m_host;

		//!T[rXX^[gĂ邩ǂ
		bool m_start;

		//!Rg[ڑ
		bool m_connected;

		//! r[[Ɛڑ
		bool m_connectedView;

		//! IɃ[v𔲂邩ǂ
		bool m_autoExitLoop;

		//! IɃT[rXvoC_I邩ǂ
		bool m_autoExitProc;

		//! [vǂ
		bool m_onLoop;
	};
}

#endif
